#include	"gpu_com.h"

#define	GPU_COM(com,r,g,b)	((r)|((g)<<8)|((b)<<16)|((com)<<24))
#define	GPU_COM2(com,x,y)	((x)|((y)<<10)|((com)<<24))
#define	H2L(x,y)	((x)|((y)<<16))

#define GETCULT(x, y) (((y)<<6)|(((x)>>4)&0x3f))
#define GETTPAGE(tp, abr, x, y) 					\
	 ( (((tp)&0x3)<<7) | (((abr)&0x3)<<5) | (((y)&0x100)>>4) | (((x)&0x3ff)>>6) )

#define	BG_X	320
#define	BG_Y	0
#define	SPR_X	320
#define	SPR_Y	256
#define	BGPAL_X	0
#define	BGPAL_Y	480
#define	SPPAL_X	0
#define	SPPAL_Y	481

#define	BG_TPAGE		(GETTPAGE(0,0,BG_X,BG_Y)|0xe1000000)
#define	SPR_TPAGE	(GETTPAGE(0,0,SPR_X,SPR_Y)|0xe1000000)
#define	BG_PAL	GETCULT(BGPAL_X,BGPAL_Y)
#define	SPR_PAL	GETCULT(SPPAL_X,SPPAL_Y)

#if 0
#define	PK_ADD(pk,size)	\
	*pk=((long)(pk+size)&0xffffff)|((size-1)<<24);pk+=size
#else
#define	PK_ADD(pk,size)	_GPU_cwb(pk+1,size-1);
#endif

typedef struct {
	short x,y,w,h;
} RECT;

static long	PacketArea[100];
static long	*MyOUT_PACKET_P = PacketArea;
static int DrawOfs;

static void plane2pixel(int no)
{
	unsigned short *C;
	unsigned long L,LL,M0,M1,*C2;
	static unsigned long buf[8];
	RECT rect;
	int j;
	C=VRAM+no*16;
	C2 = buf;
  for(j=0;j<8;j++,C++,C2++) {
    M0=C[0];
    M1=C[8];
    L =((M0&0x8888)>>3)|((M0&0x4444)<<14)|((M1&0x8888)>>1)|((M1&0x4444)<<16);
    LL=((M0&0x2222))|((M0&0x1111)<<17)|((M1&0x2222)<<2)|((M1&0x1111)<<19);
	L = ( (L|(L>>7))&0xFF00FF) | ( (LL|(LL<<7))&0xFF00FF00);
	// and,or 11, shift 10
	//37152604
	//3_1_2_0_ -> 3210
	//_7_5_6_4 -> 7654

    C2[0]=((L&0xf0f0)>>4)|((L>>16)&0xf0f0)|((L&0x0f0f)<<16)|((L&0x0f0f0000)<<4);
  }
	rect.x = (no>>5)*2+BG_X;
	rect.y = (no&31)*8+BG_Y;
	rect.w = 2;
	rect.h = 8;
	LoadImage(&rect,buf);
}

static void sprite2pixel(int no)
{
	unsigned short *C;
	unsigned long L0,L1,L2,L3,M0,M1,M2,M3,*C2;
	static unsigned long buf[32];
	RECT rect;
	int j;

	C=(VRAM+no*64);
	C2 = buf;
  for(j=0;j<16;j++,C++,C2+=2) {
    M0=C[0];
    M1=C[16];
    M2=C[32];
    M3=C[48];
    L0 =((M0&0x8888)>>3)|((M1&0x8888)>>2)|((M2&0x8888)>>1)|((M3&0x8888));
	//048c
    L1 =((M0&0x4444)>>2)|((M1&0x4444)>>1)|((M2&0x4444))|((M3&0x4444)<<1);
	//159d
    L2 =((M0&0x2222)>>1)|((M1&0x2222))|((M2&0x2222)<<1)|((M3&0x2222)<<2);
	//26ae
    L3 =((M0&0x1111))|((M1&0x1111)<<1)|((M2&0x1111)<<2)|((M3&0x1111)<<3);
	//37bf
#if 0
	M0 = ((L0&0xf0f0)>>4)|(L1&0xf0f0); //1089
	M1 = (L0&0x0f0f)|((L1&0x0f0f)<<4); //54dc
	M2 = ((L2&0xf0f0)>>4)|(L3&0xf0f0); //32ba
	M3 = (L2&0x0f0f)|((L3&0x0f0f)<<4); //76fe
	C2[0] = (M0>>8)|(M2&0xFF00)|(((M1>>8)|(M3&0xFF00))<<16);
	C2[1] = (M0&0xFF)|(M2<<8)|(((M1&0xFF)|(M3<<8))<<16);
#else
	M0 = ((L0&0xf0f0)>>4)|(L1&0xf0f0)|((L0&0x0f0f)<<16)|((L1&0x0f0f)<<20);
	// 0_8_ , 1_9_ , _4_c, _5_d
	//54dc1098
	M1 = ((L2&0xf0f0)>>4)|(L3&0xf0f0)|((L2&0x0f0f)<<16)|((L3&0x0f0f)<<20);
	//76fe32ba
	C2[0] = ((M0&0xff00ff00)>>8)|(M1&0xff00ff00);
	C2[1] = ((M0&0x00ff00ff))|((M1&0x00ff00ff)<<8);
#endif
  }
	rect.x = (no&1)*4+(no>>5)*8+SPR_X;
	rect.y = ((no>>1)&15)*16+SPR_Y;
	rect.w = 4;
	rect.h = 16;
	LoadImage(&rect,buf);
}

void RefreshLine(int Y1,int Y2)
{
	int X1,XW,Line;
	int x,y,posx,posy;
	int Yofs = DrawOfs;
	long *pk;

	pk = MyOUT_PACKET_P;

	pk[1] = GPU_COM2(GPU_CLIP_START,0,Y1+Yofs);
	pk[2] = GPU_COM2(GPU_CLIP_END,io.screen_w-1,Y2+Yofs);
	PK_ADD(pk,3);

	Y2++;
	if(!ScreenON) {
		pk[1] = GPU_COM(GPU_TILE,0,0,0);
		pk[2] = H2L(0,Y1+Yofs);
		pk[3] = H2L(io.screen_w,Y2-Y1);
		PK_ADD(pk,4);
	}
	else {
	y = Y1+ScrollY;
	posy = Y1-(y&7)+Yofs;
	y/=8;
	XW=io.screen_w/8;

  for(Line=Y1;Line<Y2;Line+=8,y++,posy+=8) {
    word *vp;
	x = ScrollX/8;
	posx = -(ScrollX&7);
	vp = &VRAM[(y&(io.bg_h-1))*io.bg_w];
	for(X1=0;X1<=XW;X1++,x++,posx+=8){
		int no,uv;
		no = vp[x&(io.bg_w-1)];
		uv = H2L(((no>>2)&0xF8)|((no&31)<<(8+3)),BG_PAL+(no>>12));
		no&=0xFFF;
		if (vchange[no]) { vchange[no]=0; plane2pixel(no); }
		pk[1] = BG_TPAGE+(no>>10);
		pk[2] = GPU_COM(GPU_SPRT8|NOSHADE,0,0,0);
		pk[3] = H2L(posx&0xffff,posy);
		pk[4] = uv;
		PK_ADD(pk,5);
	}
  }
  	}
	/* Refresh Sprite */
  if (SpriteON) {
	int n;
	SPR *spr;

	spr = (SPR*)SPRAM + 63;

	for(n=0;n<64;n++,spr--){
		int x,y,no,atr,cgx,cgy;
		int w,h,tpage,uv,i;
		y = (spr->y&1023)-64;
		x = (spr->x&1023)-32;
		no= (spr->no>>1)&1023;
		atr=spr->atr;
		cgx = (atr>>8)&1;
		cgy = (atr>>12)&3;
		no &= ~(cgy*2+cgx);
		w = (cgx+1)*16;
		h = (cgy+1)*16;
		if (y>=Y2 || y+w<Y1 || x>=io.screen_w || x+h<0) continue;
		for(i=no;i<no+(cgy+1)*2;i++) {
			if (((long*)vchange)[i]) {
				((long*)vchange)[i]=0;
				sprite2pixel(i);
			}
		}

		tpage = SPR_TPAGE+(no>>8);
		uv = ((no&1)*16) | (no&0xE0) | (((no>>1)&15)<<(4+8));
		if (atr&H_FLIP) {tpage|=H_REV; uv+=w-1;}
		if (atr&V_FLIP) {tpage|=V_REV; uv+=(h-1)<<8;}
		pk[1] = tpage;
		pk[2] = GPU_COM(GPU_SPRT|NOSHADE,0,0,0); //sprite command
		pk[3] = H2L(x&0xffff,y+Yofs);
		pk[4] = H2L(uv,SPR_PAL+(atr&15));
		pk[5] = H2L(w,h);
		PK_ADD(pk,6);
	}
  }
	MyOUT_PACKET_P=pk;
}

void RefreshScreen(void)
{
	RECT rect;

	SetGPUStatus(GPU_COM2(GPU_DISP_OFFSET,0,DrawOfs));
	DrawOfs^=240;

	rect.x = BGPAL_X;
	rect.y = BGPAL_Y;
	rect.w = 256;
	rect.h = 2;
	LoadImage(&rect,&Pal);

}